//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

bool differenceOne (int elem1, int elem2)
{
    return elem1 + 1 == elem2 || elem1 - 1 == elem2;
}



int main()
{
  //  
  int source[] = { 1, 4, 4, 6, 1, 2, 2, 3, 1, 6, 6, 6, 5, 7,
                    5, 4, 4 };
  int sourceNum = sizeof(source)/sizeof(source[0]);

  //  coll  source
  list<int> coll;
  copy(source, source+sourceNum,      // 
       back_inserter(coll));          // 
  PRINT_ELEMENTS(coll," :\n");

  //   coll    
  cout << ToRus("    :\n");
  unique_copy(coll.begin(), coll.end(),          // 
              ostream_iterator<int>(cout," "));  // 
  cout << endl;

  //   coll    
  //  ,   1
  cout << ToRus("    \n ,   1:\n");
  unique_copy(coll.begin(), coll.end(),         // 
              ostream_iterator<int>(cout," "),  // 
              differenceOne);                   //  
  cout << endl;


  getch();
  return 0;
}

//---------------------------------------------------------------------------